

/* 	
			UNICON PROJECT

   		    Copyright (C) 1999 TLDN
	
   Authors:	Li Qi Chen <chrisl@turbolinux.com.cn>
		Arthur Ma  <arthur.ma@turbolinux.com.cn>
		Justin Yu  <justiny@turbolinux.com.cn>

   Homepage:    http://turbolinux.com.cn/TLDN/chinese/project/unicon/index.html
   Mailinglist: unicon@turbolinux.com.cn 	
   Download:    http://turbolinux.com.cn/TLDN/chinese/project/unicon/download.html

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

/* key -- key processing module */

#ifndef	KEY_H
#define	KEY_H

/* special function key use to active input method */
#define NR_SPEC_KEY     18

#define CTRL_ALT_0      200
#define CTRL_ALT_1      201
#define CTRL_ALT_2      202
#define CTRL_ALT_3      203
#define CTRL_ALT_4      204
#define CTRL_ALT_5      205
#define CTRL_ALT_6      206
#define CTRL_ALT_7      207
#define CTRL_ALT_8      208
#define CTRL_ALT_9      209

#define CTRL_ALT_A      210
#define CTRL_ALT_X      211
#define CTRL_ALT_P      212
#define CTRL_ALT_N      213
#define CTRL_ALT_R      214

#define CTRL_SPACE      215
#define SHIFT_SPACE     216
#define SCROLL_LOCK     217

#define ALT_F1		220
#define CTRL_ALT_F1	220
#define ALT_F2		221
#define	CTRL_ALT_F2	221
#define ALT_F3		222
#define	CTRL_ALT_F3	222
#define ALT_F4          223
#define CTRL_ALT_F4     223
#define ALT_F5          224
#define CTRL_ALT_F5     224
#define ALT_F6          225
#define CTRL_ALT_F6     225
#define ALT_F7          226
#define CTRL_ALT_F7     226

/* system menu trigger */
#define CTRL_F5         227  
#define ALT_SPACE       228
#define F1_HELP         229

/* User Defined Phrase Support */
#define SHIFT_TAB        230

void SetupKeymap(void);
void RestoreKeymap(void);
void KeymapInit(void);
void KeymapCleanup(void);
void ProcessNormalModeKey(int tty_fd,unsigned char c);
#endif
